﻿Imports System.Security.Cryptography
Imports System.Text
Imports System.IO

Public Class Form1
    Public firma As String
    Private _masterPassword As String = String.Empty
    Private _dataPath As String = "accounts.xml"

    Protected Overrides Sub OnLoad(e As EventArgs)
        Using mP As New MasterPassword()
            If mP.ShowDialog() = DialogResult.OK Then
                _masterPassword = mP.txtPassword.Text
            Else
                Close()
            End If
        End Using

        Try
            LoadData()
        Catch ex As Exception
            MessageBox.Show("Incorrect password")
            Close()
        End Try

        MyBase.OnLoad(e)
    End Sub

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        SaveData()
    End Sub

    Private Sub SaveData()
        If File.Exists(_dataPath) Then File.Delete(_dataPath)

        Using cS As CryptoStream = GetEncryptionStream()
            Me.AccountDetailsDataSet1.WriteXml(cS)
        End Using
    End Sub

    Private Sub LoadData()
        If File.Exists(_dataPath) Then
            Using cS As CryptoStream = GetDecryptionStream()
                Me.AccountDetailsDataSet1.ReadXml(cS)
            End Using
        End If
    End Sub

    Private Function GetEncryptionStream() As CryptoStream
        Dim key As New Rfc2898DeriveBytes(_masterPassword, New Byte() {10, 255, 255, 7, 14, 16, 23, 155})
        Dim x As New TripleDESCryptoServiceProvider()
        Dim fS As FileStream = Nothing

        x.Key = key.GetBytes(x.KeySize \ 8)
        x.IV = key.GetBytes(x.BlockSize \ 8)
        fS = New FileStream(_dataPath, FileMode.Create, FileAccess.ReadWrite, FileShare.None)

        Return New CryptoStream(fS, x.CreateEncryptor(), CryptoStreamMode.Write)
    End Function

    Private Function GetDecryptionStream() As CryptoStream
        Dim key As New Rfc2898DeriveBytes(_masterPassword, New Byte() {10, 255, 255, 7, 14, 16, 23, 155})
        Dim x As New TripleDESCryptoServiceProvider()
        Dim fS As FileStream = Nothing

        x.Key = key.GetBytes(x.KeySize \ 8)
        x.IV = key.GetBytes(x.BlockSize \ 8)
        fS = New FileStream(_dataPath, FileMode.Open, FileAccess.ReadWrite, FileShare.None)

        Return New CryptoStream(fS, x.CreateDecryptor(), CryptoStreamMode.Read)
    End Function

    Private Sub btnDelete_Click(sender As Object, e As EventArgs)
        If Not Me.AccountsBindingSource.Current Is Nothing Then
            Me.AccountsBindingSource.RemoveCurrent()
        End If

        SaveData()
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click


        Dim auswahl As New Form2()
        auswahl.AccountDetailsDataSet = Me.AccountDetailsDataSet1
        auswahl.LieferantBindingSource.DataSource = Me.AccountDetailsDataSet1
        auswahl.Show()


    End Sub
End Class
